/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem E. Exact Measurement                                   */
/*                                                                */
/* Original idea         Pavel Mavrin                             */
/* Problem statement     Pavel Mavrin                             */
/* Test set              Pavel Mavrin                             */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Andrey Halyavin                          */
/******************************************************************/

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.io.BufferedWriter;
import java.util.InputMismatchException;
import java.util.Comparator;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.Writer;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class exact_halyavin {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("exact.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("exact.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		Exact solver = new Exact();
		solver.solve(1, in, out);
		out.close();
	}
}

class Exact {
    static class Data {
        long qk;
        int numbers;
    }

    Data[][] data;
    int[] len;
    long[] deg10;
    int[] ans;
    int lenAns;
	public void solve(int testNumber, InputReader in, OutputWriter out) {
        long x = in.readLong();
        int n = in.readInt();
        len = new int[19];
        data = new Data[19][n];
        for (int i = 0; i < 19; ++i) for (int j = 0; j < n; ++j) data[i][j] = new Data();
        deg10 = new long[19];
        deg10[0]=1;
        for (int i=1;i<deg10.length;i++){
            deg10[i]=10*deg10[i-1];
        }
        for (int i=0;i<n;i++){
            int k = in.readInt();
            long q = in.readLong()*deg10[k];
            data[k][len[k]].qk=q;
            data[k][len[k]].numbers=i+1;
            len[k]++;
        }
        for (int i=0;i<19;i++){
            Arrays.sort(data[i], 0, len[i], new Comparator<Data>() {
                @Override
                public int compare(Data o1, Data o2) {
                    return Long.signum(o1.qk - o2.qk);
                }
            });
        }
        ans=new int[n];
        lenAns = 0;
        int shift = 0;
        long remain = 0;
        while (x>0){
            long t = (x%10)*deg10[shift];
            long diff = Math.min(remain,t);
            t-=diff;
            remain-=diff;
            while (t > 0){
                long max = -1;
                int optk = -1;
                for (int i=0;i<=shift;i++){
                    if (len[i]==0){
                        continue;
                    }
                    if (data[i][len[i]-1].qk>max){
                        max = data[i][len[i]-1].qk;
                        optk=i;
                    }
                }
                if (optk == -1) {
                    out.printLine(-1);
                    return;
                }
                remain = max;
                ans[lenAns]=data[optk][len[optk]-1].numbers;
                lenAns++;
                len[optk]--;
                diff = Math.min(remain, t);
                t-=diff;
                remain-=diff;
            }
            shift++;
            x /= 10;
        }
        out.printLine(lenAns);
        for (int i=0;i<lenAns;i++){
            out.print(ans[i]+" ");
        }
        out.printLine();
	}
}

class InputReader {

	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public long readLong() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		long res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}

class OutputWriter {
	private final PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(Object...objects) {
		for (int i = 0; i < objects.length; i++) {
			if (i != 0)
				writer.print(' ');
			writer.print(objects[i]);
		}
	}

	public void printLine(Object...objects) {
		print(objects);
		writer.println();
	}

	public void close() {
		writer.close();
	}

	}


