/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem E. Exact Measurement                                   */
/*                                                                */
/* Original idea         Pavel Mavrin                             */
/* Problem statement     Pavel Mavrin                             */
/* Test set              Pavel Mavrin                             */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Vitaliy Aksenov                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class exact_va implements Runnable {
	public static void main(String[] args) {
		new Thread(new exact_va()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public class Ruler implements Comparable<Ruler> {
		int id;
		long l;

		public Ruler(int id, long l) {
			this.id = id;
			this.l = l;
		}

		public int compareTo(Ruler r) {
			return r.l == l ? id - r.id : (int) Math.signum(r.l - l);
		}
	}

	public void solve() throws IOException {
		long x = nextLong();
		int n = nextInt();

		int max = 19;

		ArrayList<Ruler>[] rulers = new ArrayList[max];

		for (int i = 0; i < rulers.length; i++) {
			rulers[i] = new ArrayList<Ruler>();
		}

		for (int i = 0; i < n; i++) {
			int k = nextInt();
			long l = (long) (nextLong() * Math.pow(10, k));

			rulers[k].add(new Ruler(i + 1, l));
		}

		TreeSet<Ruler> possible = new TreeSet<Ruler>();
		long take = 0;

		ArrayList<Integer> ans = new ArrayList<Integer>();

		long mod = 10;
		for (int i = 0; i < max; i++) {
			long need = x % mod;
			if (i == max - 1) {
				need = x;
			}

			for (Ruler r : rulers[i]) {
				possible.add(r);
			}

			while (take < need) {
				Ruler r = possible.pollFirst();
				if (r == null) {
					out.println(-1);
					return;
				}
				take += r.l;
				ans.add(r.id);
			}

			mod *= 10;
		}

		Collections.sort(ans);

		out.println(ans.size());
		for (int z : ans) {
			out.print(z + " ");
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("exact.in"));
			out = new PrintWriter("exact.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}

