/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem H. Hyperdrome                                          */
/*                                                                */
/* Original idea         Vitaliy Aksenov                          */
/* Problem statement     Vitaliy Aksenov                          */
/* Test set              Vitaliy Aksenov                          */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Vitaliy Aksenov                          */
/******************************************************************/

import java.io.*;
import java.util.*;

public class hyperdrome_va_hashmap implements Runnable {
	public static void main(String[] args) {
		new Thread(new hyperdrome_va_hashmap()).run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public void solve() throws IOException {
		int n = nextInt();
		char[] c = nextToken().toCharArray();
		for (int i = 0; i < c.length; i++) {
			if (c[i] <= 'Z') {
				c[i] = (char) (c[i] - 'A' + 26);
			} else {
				c[i] = (char) (c[i] - 'a');
			}
		}

		long ans = 0;
		HashMap<Long, Integer> masks = new HashMap<Long, Integer>();

		masks.put(0L, 1);
		long mask = 0;
		for (int i = 0; i < c.length; i++) {
			mask ^= 1L << c[i];

			if (!masks.containsKey(mask)) {
				masks.put(mask, 0);
			}

			int z = masks.get(mask);

			ans += z;
			masks.put(mask, z + 1);

			for (int j = 0; j < 52; j++) {
				if (masks.containsKey(mask ^ (1L << j))) {
					ans += masks.get(mask ^ (1L << j));
				}
			}
		}

		out.println(ans);
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("hyperdrome.in"));
			out = new PrintWriter("hyperdrome.out");

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}

