/******************************************************************/
/* ACM ICPC 2012-2013                                             */
/* Northeastern European Regional Contest                         */
/* St Petersburg - Barnaul - Tashkent - Tbilisi, December 2, 2012 */
/******************************************************************/
/* Problem J. Jumping Around                                      */
/*                                                                */
/* Original idea         Andrey Stankevich                        */
/* Problem statement     Andrey Stankevich                        */
/* Test set              Andrey Stankevich                        */
/******************************************************************/
/* Solution                                                       */
/*                                                                */
/* Author                Petr Mitrichev                           */
/******************************************************************/

import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.BufferedWriter;
import java.util.InputMismatchException;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.Writer;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class jumping_petr {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("jumping.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("jumping.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		Jumping solver = new Jumping();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class Jumping {
    int[] seq;
    int n;

	public void solve(int testNumber, InputReader in, OutputWriter out) {
        int a = in.readInt();
        int b = in.readInt();
        int c = in.readInt();
        int fc = (c - 3) / 3;
        c -= 3 * fc;
        int fb = (b - 3) / 2;
        b -= 2 * fb;
        int fa = a - 3;
        a -= fa;
        n = 1 + a + b + c;
        seq = new int[n];
        if (!rec(0, 0, 0, a, b, c, false, false)) throw new RuntimeException();
        int shift = 0;
        boolean first = true;
        while (fa > 0) {
            if (first) first = false; else out.print(" ");
            out.print(shift);
            ++shift;
            --fa;
        }
        for (int i = 0; i < fc; ++i) {
            if (first) first = false; else out.print(" ");
            out.print(shift);
            shift += 3;
        }
        for (int i = 0; i < n; ++i) {
            if (first) first = false; else out.print(" ");
            out.print(shift + seq[i]);
            if (seq[i] == 1 || seq[i] == 2) {
                for (int j = 0; j < fc; ++j) {
                    if (first) first = false; else out.print(" ");
                    out.print(shift + seq[i] - 3 * (j + 1));
                }
                for (int j = fc - 1; j >= 0; --j) {
                    if (first) first = false; else out.print(" ");
                    out.print(shift + seq[i + 1] - 3 * (j + 1));
                }
                fc = 0;
            }
            if (seq[i] == n - 2 || seq[i] == n - 1) {
                for (int j = 0; j < fb; ++j) {
                    if (first) first = false; else out.print(" ");
                    out.print(shift + seq[i] + (j + 1) * 2);
                }
                for (int j = fb - 1; j >= 0; --j) {
                    if (first) first = false; else out.print(" ");
                    out.print(shift + seq[i + 1] + (j + 1) * 2);
                }
                fb = 0;
            }
        }
        out.printLine();
	}

    private boolean rec(int at, int usedMask, int pos, int a, int b, int c, boolean hadNice1, boolean hadNice2) {
        if (at < 0 || at >= n || (usedMask & (1 << at)) != 0 || a < 0 || b < 0 || c < 0) return false;
        usedMask |= 1 << at;
        seq[pos] = at;
        if (a == 0 && b == 0 && c == 0) {
            if (hadNice1 && hadNice2) {
                return true;
            }
            return false;
        }
        for (int dx = -3; dx <= 3; ++dx) if (dx != 0) {
            int nat = at + dx;
            int na = a;
            int nb = b;
            int nc = c;
            if (Math.abs(dx) == 1) --na;
            if (Math.abs(dx) == 2) --nb;
            if (Math.abs(dx) == 3) --nc;
            if (rec(nat, usedMask, pos + 1, na, nb, nc, hadNice1 || (at == n - 1 && nat == n - 2) || (at == n - 2 && nat == n - 1), hadNice2 || (at == 1 && nat == 2) || (at == 2 && nat == 1))) return true;
        }
        return false;
    }
}

class InputReader {

	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}

class OutputWriter {
	private final PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(Object...objects) {
		for (int i = 0; i < objects.length; i++) {
			if (i != 0)
				writer.print(' ');
			writer.print(objects[i]);
		}
	}

	public void printLine(Object...objects) {
		print(objects);
		writer.println();
	}

	public void close() {
		writer.close();
	}

	}


